import { useThrottle, World } from "@rbxts/matter"
import { Health } from "ReplicatedStorage/ecs/components"

/**
 * Health components regenerate health based on the regeneration value.
 */
function healthRegenerates(world: World): void {
	for (const [id, health] of world.query(Health)) {
        if (health.health <= 0) continue

        const newHealth = math.clamp(health.health + health.regeneration, 0, health.maxHealth)

        if (useThrottle(1)) {
            world.insert(
                id,
                health.patch({
                    health: newHealth
                })
            )
        }
	}
}

export = healthRegenerates